/* Classic Ladder Project */
/* Copyright (C) 2001 Marc Le Douarain */
/* mavati@club-internet.fr */
/* http://www.multimania.com/mavati/classicladder */
/* February 2001 */
/* Last update : 17 April. 2001 */
/* --------------------------------------- */
/* Access a variable for reading / writing */
/* --------------------------------------- */
/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

char InitVars()
{
    int NumVar;
    for (NumVar=0; NumVar<NBR_BITS; NumVar++)
        VarArray[NumVar] = FALSE;
}

char ReadVar(int TypeVar,int Offset)
{
    switch(TypeVar)
    {
        case VAR_MEM_BIT:
            return VarArray[Offset];
        case VAR_TIMER_DONE:
            return TimerArray[Offset].OutputDone;
        case VAR_TIMER_RUNNING:
            return TimerArray[Offset].OutputRunning;
        case VAR_MONOSTABLE_RUNNING:
            return MonostableArray[Offset].OutputRunning;
        default:
            printf("!!! Error : Type not found in ReadVar()\n");
    }
}

char WriteVar(int TypeVar,int NumVar,char Value)
{
    switch(TypeVar)
    {
        case VAR_MEM_BIT:
            VarArray[NumVar] = Value;
            if (Value)
                gtk_toggle_button_set_active((GtkToggleButton *)chkvar[NumVar],TRUE);
            else
                gtk_toggle_button_set_active((GtkToggleButton *)chkvar[NumVar],FALSE);
            break;
        default:
            printf("!!! Error : Type not found in WriteVar()\n");
            break;
    }
}

void DumpVars()
{
    int NumVar;
    for (NumVar=0; NumVar<20; NumVar++)
        printf("Var %d=%d\n",NumVar,ReadVar(VAR_MEM_BIT,NumVar));
}

